;; lisp file for xyzzy ver0.2.2.233
;;;ddwin-search.l
;;;DDwin̎g悤ɂ

;(load-library "ddwin-search")

;;;original product was made by suda.
;;;remodel my dictionary

(provide "ddwin-search")

(in-package "editor")

(export '(ddwin-app
	  ddwin-search-kanjigen-selection
	  ddwin-search-koujien-selection
	  ddwin-search-chujiten-selection
	  ddwin-search-pc-selection
	  ddwin-search-group-j-selection
	  ddwin-search-group-e-selection
	  ddwin-search-group-bible-selection
	  ddwin-search-group-pc-selection
	  ddwin-search-group-all-selection
	  get-current-word-or-selection
	  backward-word-stop
	  ;goto-word-head
	  ;init-ddwin-menu
	  ))

;;;;;;;;;;;;;;;;DDwin
(defun ddwin-app ()
  (interactive)
  (launch-application "C:/Program Files/DDwin/ddwin.exe"))

;;launch-application̎w  DDwin;;(ddwin-search-chujiten-selection)
;; "C:/Program Files/DDwin/ddwin.exe" DDwiñpX
;; , "2" DDwin𕡐NȂ
;; , "{" O[v
;; , "5Ԗ" 
;; , "word"  

;;;;;;;;;;;;;;;;Pw
;;"{" O[v
;; , PԖځ@
(defun ddwin-search-kanjigen-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
	(launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,{,1," word))))

;; , QԖځ@L
(defun ddwin-search-koujien-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
	(launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,{,2," word))))

;; , TԖځ@Ёipa@apj
(defun ddwin-search-chujiten-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
	(launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,{,5," word))))

;;"PC" O[v
;; , RԖ ʐMp
(defun ddwin-search-pc-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
	(launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,PC,3," word))))

;;;;;;;;;;;;;;;;O[vw
;;O[vh / { :  L t Oȓ  T
(defun ddwin-search-group-j-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,{,G1," word))))

;;O[vh / O :  pXy Xyp pC^ C^p p- -p Rp RƉp p-
(defun ddwin-search-group-e-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,O,G1," word))))

;;O[vh / Bible : Eas HIT 
(defun ddwin-search-group-bible-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,Bible,G1," word))))

;;O[vh / PC : FOL VER ʐMp 
(defun ddwin-search-group-pc-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,PC,G1," word))))

;;O[vh / SĂ̎
(defun ddwin-search-group-all-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,2,SĂ̎,G1," word))))
    
;;;;;;;;;;;;;;;;̎擾
(defun get-current-word-or-selection ()
  (interactive)
  (let (word)
    (if (pre-selection-p)
	(let ((start (selection-point))
	      (end (selection-mark)))
	  (setq word (buffer-substring start end)))
      (save-excursion ;;J[\ʒuACT[V|Cg߂Ă
	(setq word
	      (buffer-substring
	       ;(progn (goto-word-head) (point))
	       ;(progn (backward-word) (point))
	       ;(point) ;;肭Ȃ̂ŃJ[\ʒuɓ
	       (progn (backward-word-stop) (point)) ;;P̓ňړ~߂
	       (progn (forward-word) (point)))
	      )
	))
    word))

;;;;;;;;;;;;;;;;P̓ňړ~߂
;(char= (preceding-char) #\LFD) ;#\SPC ;#\^ ;#\TAB
;(char= (following-char) (character "^")
;(setq pchar (preceding-char))
;(when (/= 0 (point))
;(forward-char 1)
;(looking-back " ")

;;forward-word -1 LȂǂ͂Ƃ΂Ă܂̂
;;(unless (looking-at "\\<");;P̍sɃ}b`͉p݂̂Ȃ̂
;;ƃJ^Ji͒PAЂ炪Ȃ͂Ƃ΂݂Ȃ̂
;;ÕL󔒂Ȃǂ͎̎~܂悤ɂ
;;ł̃L󔒂Ȃǂ͈̎ړ

;;IɁBBB̓_BdȂ̂œIȂ͎̂̂ĂāAmɎ~܂`ŌŒ
;;p̒P̓Ȃ~߂
;;O󔒂ŁA낪󔒂łȂȂ~߂
(defun backward-word-stop ()
  (interactive)
  (when (forward-char -1)
    (setq bchar (looking-at "\\([ \t@\n]\\)"))
    (forward-char 1)
    (setq fchar (looking-at "\\([ \t@\n]\\)"))
    (unless (or (looking-at "\\<")
		(and bchar
		     (null fchar)))
      (forward-word -1))
    )
  )

#|
;;IɃXgbvƓJԂ悤ɁBBBƁAA
;;ϐłQڂ̃`FbN͂߁B[U[̔CӂŃJ[\̈ʒuςĂBBB
(defvar-local *b-w-stop* nil)

(defun backward-word-stop ()
  (interactive)
  ;;p̒P̓`FbN
  (if (looking-at "\\<")

      ;;Ȃ
      (if *b-w-stop*
	  (progn
	    (forward-word -1) ;;Qڂ͓
	    (setq *b-w-stop* nil) ;;
	    )
	(setq *b-w-stop* t) ;;ŏ̂P͎~܂
	)

    ;;łȂȂ ;;̋󔒃^us`FbN
    (if (looking-at "\\([ \t@\n]\\)")
	;;󔒂Ȃ瓮ē
	(progn
	  (forward-word -1)
	  (setq *b-w-stop* nil))
      ;;󔒂łȂȂ ;;Ő󔒃^us`FbN
      (if (looking-back "\\([ \t@\n]\\)")
	  ;;Ȃ
	  (if *b-w-stop*
	      (progn
		(forward-word -1) ;;Qڂ͓
		(setq *b-w-stop* nil) ;;
		)
	    (setq *b-w-stop* t) ;;ŏ̂P͎~܂
	    )
	;;łȂȂ瓮
	(progn
	  (forward-word -1)
	  (setq *b-w-stop* nil))
	)
      )
    )
  )
|#

#|
;;;;;;;;;;;;;;;;
;; P̐擪
(defun goto-word-head ()
  (cond ((looking-at " ")
		 (backward-word 1))
		((looking-at "\\<"))
		(t
		 (backward-word 1))))
|#

;;;;;;;;;;;;;;;; }j[U@insert menu tools c[
;;c[̓ɑ} menu item 0
(defvar *ddwin-popup-menu* nil)

;;Alt̊蓖ăL[ɍȁBBBƂ肠Alt-Q
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (init-ddwin-menu)
	      (when (setq menu (get-menu *app-menu* 'ed::tools))
		(insert-popup-menu menu 0 *ddwin-popup-menu* "DDwin(&Q)")
		(insert-menu-separator menu 1 'tool-ddwin-sep)
		)
	      )
	  )

(defun init-ddwin-menu ()
  (or *ddwin-popup-menu*
      (setq *ddwin-popup-menu* (create-popup-menu)))

  (setq *ddwin-popup-menu*
	(define-popup-menu
	  (:item nil "ddwinN(&D)"
	   'ddwin-app)
	  :sep
	  (:item nil "(&J)"
	   'ddwin-search-kanjigen-selection)
	  (:item nil "L(&K)"
	   'ddwin-search-koujien-selection)
	  (:item nil "Ёipaapj(&E)"
	   'ddwin-search-chujiten-selection)
	  (:item nil "PCFʐMp(&P)"
	   'ddwin-search-pc-selection)
	  :sep
	  (:item nil "ٰ߁F{(&N)"
	   'ddwin-search-group-j-selection)
	  (:item nil "ٰ߁FO(&F)"
	   'ddwin-search-group-e-selection)
	  (:item nil "ٰ߁FBible(&B)"
	   'ddwin-search-group-bible-selection)
	  (:item nil "ٰ߁FPC(&C)"
	   'ddwin-search-group-pc-selection)
	  (:item nil "ٰ߁FSĂ̎(&A)"
	   'ddwin-search-group-all-selection)
	  )
	)
  )

;;;;;;;;;;;;;;;; }j[@ENbN@obt@[
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (init-ddwin-menu)
	      (when *app-popup-menu*
		(setq ip -1)
		(while (get-menu *app-popup-menu* (incf ip) t))
		(insert-menu-separator *app-popup-menu* ip 'ddwin-sep)
		(insert-popup-menu *app-popup-menu* (incf ip) *ddwin-popup-menu* "DDwin(&Q)")
		)
	      )
	  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#|
;;;Ăяo
(defun launch-application (app)
  (interactive "e% " :history0 'execute)
  (call-process app :no-std-handles t :show :show
		:exec-directory *launch-app-directory*))
|#

;;;;;;;;;;;;;;;;(defun launch-application (app) ̎w
;;;original product was made by suda.
;;;arranged by TKI.
;;;parameter  DDWIN QƂĂBƂ̂ƁBBB

;;;܂Ƃ߁@O[v̂Ƃ
;;;DDwinpX@DDwin̋N@@O[v@ԍ܂̓TuO[v@

;;;DDwiñpX
;"C:/Program Files/DDwin/ddwin.exe"

;;;1 ݒt@C@env-file ;;̎w͂Ȃ̂ȁH悭킩ȂBP悤̂łȂŁBBB
;1

;;;DDwin̋N@0/wcȂ 1cO[v͋NȂ 2cNȂ
;2

;;;wȂOgpO[vJ
;"{"

;;;ԍ PƂ̎܂̓TuO[vw肷
;;;1cڂ̎J  ȉ2A3Ȃ
;;;G1cڂ̃O[vɑ΂ċh  ȉG2AG3Ȃ
;;;wcIԂ̎ŋh
;5 ;;TԖڌ

;;;
;word


;;(launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,1,,1," word))
;;(launch-application (concat "C:/Program Files/DDwin/ddwin.exe ,1,{,5," word));;5Ԗڌ
