;;; lisp file for xyzzy ver0.2.2.233
;;; extend-copy.l ver0.1.0.3 // for text-mode or else mode // crayonzen [2006-06-16]01:35:34(+0900)

(provide "extend-copy")

(in-package "editor")

(export '(copy-selection-and-to-clipboard
	  kill-selection-and-to-clipboard
	  ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;gRs[Jbgy[Xg
;;Nbv{[h*selection-ring*ɓɊi[B
;;F7                  kill-selection
;;F8                  copy-selection
;;F9                  yank-selection
;;`*selection-ring*͒ʏ̃y[Xĝ݁B

;;;;(Esc-w Rs[@C-w Jbg)yankƎdlɂB
;;;;yank̎dl(C-y 'yank y[Xg@M-y 'yank-pop@*kill-ring*y[Xg)

;;L[ݒ
;;M-v*selection-ring*y[Xgɐݒ
;;(global-set-key #\M-v 'yank-selection-and-pop);Ƀy[Xg(i[͏)
;;
;;ring-popup-menu.lt@Cgă|bvAbvB
;;(load-library "ring-popup-menu")
;;(global-set-key #\M-y 'kill-ring-popup-menu)
;;(global-set-key #\M-v 'selection-ring-popup-menu)

(defun copy-selection-and-to-clipboard ()
  (interactive)
  (when (pre-selection-p)
    (cond ((eql (get-selection-type) 3) ;`
	   (let ((*dont-clear-selection* t))
	     (rectangle-selection-to-clipboard #'copy-rectangle-selection) ;clipboard
	     (copy-rectangle-selection)
	     (let ((string (get-clipboard-data))) ;selection-ring (from clipboard)
	       (when string
		 (selection-new 2 string)))
	     (if *shodat-copy-mode*
		 (continue-pre-selection)
	       (stop-selection))))
	  (t
	   (let ((type (get-selection-type)))
	     (selection-start-end (start end) ;clipboard
	       (copy-region-to-clipboard start end)
	       (start-selection type t end))
	     (selection-start-end (start end) ;selection-ring
	       (selection-new type (buffer-substring start end))
	       (if *shodat-copy-mode*
		   (start-selection type t end))
	       )))
	  ))
  t)

(defun kill-selection-and-to-clipboard ()
  (interactive)
  (cond ((eql (get-selection-type) 3) ;`
	 (if (pre-selection-p)
	   (let ((*dont-clear-selection* t))
	     (rectangle-selection-to-clipboard #'copy-rectangle-selection) ;clipboard
	     (let ((string (get-clipboard-data))) ;selection-ring (from clipboard)
	       (when string
		 (selection-new 2 string)))
	     (kill-rectangle-selection))))
	(t
	 (let ((type (get-selection-type)))
	   (selection-start-end (start end) ;selection-ring
	     (selection-new type (buffer-substring start end))
	     (start-selection type t end))
	   (selection-start-end (start end) ;clipboard@killclipboardȂ̂ring
	     (kill-region-to-clipboard start end))))
	)
  t)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;`ringi[
;;yank-selectionł̃y[XgŁu\t-`v͂Ȃ̂
;;ringւ̊i[ł悭As[hA[h͊֌WȂ̂ŁAƂ肠ʏ2ɐݒB
;;i⑫F[hݒringɊi[Bs[h1ƃy[Xg̎ɍsy[Xgj

;;(eql (get-selection-type) 3) rectangle
;;(eql (get-selection-type) 2) normal select (selection-point)(selection-mark)
;;(eql (get-selection-type) 1) (selection-point)(selection-mark)->(goto-virtual-bol)(point)
;;region.l:20:(defvar *kill-ring-max* 16)
;;select.l:59:(defvar *selection-ring-max* 16)

;;  nil   IȂA
;;  1     s[hI
;;  2     [hI
;;  3     `I
;;s[hI start-selection-as-line

;;`
;;copy-selection -> copy-rectangle-selection -> (operate-on-rectangle-selection :copy t)
;;operate-on-rectangle-selection (&key copy delete clear open string) ->
;;operate-on-rectangle (p1 p2 c1 c2 &key copy delete clear open string)
;;